<template lang="pug">
transition(:name="props.anim" :appear="props.appear" :mode="props.mode"
           @enter="onEnter" @leave="onLeave")
  slot
</template>
<script setup>
import { computed, defineEmits, defineProps } from "vue";
import Anim from "./BaseAnimation.js";

/**
 * @typedef {import('vue').VNode} VNode
 * @typedef {import('vue').ComponentPublicInstance} ComponentPublicInstance
 * @typedef {import('./BaseAnimation.js').Anim} AnimType
 * @typedef {import('./BaseAnimation.js').AnimOptions} AnimOptions
 */

const props = defineProps({
  appear: { type: Boolean, default: true },
  anim: {
    type: /** @type {V.PropType<keyof Anim>} */ (String),
    default: Anim.default
  },
  mode: {
    type: /** @type {V.PropType<"in-out" | "out-in" | "default" | "">} */ (String),
    default: "out-in"
  }, /* set to empty for simultaneous*/
  options: {
    type: /** @type {V.PropType<AnimOptions>} */ (Object),
    default: null
  }
});

const emit = defineEmits([ "onEnter", "onLeave" ]);

const animation = computed(
  () => /** @type {AnimType} */ (Anim[/** @type {keyof Anim} */ (props.anim)] ?? {}));

const animOptions = computed(
  () => Object.assign({ appear: props.appear }, props.options));

/**
 * @param {VNode|ComponentPublicInstance|Element} elt
 * @param {function} done
 */
function onEnter(elt, done) {
  emit("onEnter", elt);
  if (animation?.value?.in) {
    animation.value.in(elt, animOptions.value, done);
  }
  else {
    done();
  }
}

/**
 * @param {VNode|ComponentPublicInstance|Element} elt
 * @param {function} done
 */
function onLeave(elt, done) {
  emit("onLeave", elt);
  if (animation?.value?.out) {
    animation.value.out(elt, animOptions.value, done);
  }
  else {
    done();
  }
}

</script>
